"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const request = require("superagent");
/**
 * A sample API that uses a petstore as an example to demonstrate features in the swagger-2.0 specification
 * @class Test
 * @param {(string)} [domainOrOptions] - The project domain.
 */
class Test {
    constructor(domain, logger) {
        this.logger = logger;
        this.domain = "http://petstore.swagger.io/api";
        this.errorHandlers = [];
        this.find = pet;
        this.by = idURL(parameters, {
            'id': number,
            $queryParameters: any,
            $domain: string
        });
        if (domain) {
            this.domain = domain;
        }
    }
    getDomain() {
        return this.domain;
    }
    addErrorHandler(handler) {
        this.errorHandlers.push(handler);
    }
    request(method, url, body, headers, queryParameters, form, reject, resolve) {
        if (this.logger) {
            this.logger.log(`Call ${method} ${url}`);
        }
        let req = request(method, url).query(queryParameters);
        Object.keys(headers).forEach(key => {
            req.set(key, headers[key]);
        });
        if (body) {
            req.send(body);
        }
        if (typeof (body) === 'object' && !(body.constructor.name === 'Buffer')) {
            req.set('Content-Type', 'application/json');
        }
        if (Object.keys(form).length > 0) {
            req.type('form');
            req.send(form);
        }
        req.end((error, response) => {
            if (error || !response.ok) {
                reject(error);
                this.errorHandlers.forEach(handler => handler(error));
            }
            else {
                resolve(response);
            }
        });
    }
    findPetsURL(parameters) {
        let queryParameters = {};
        const domain = parameters.$domain ? parameters.$domain : this.domain;
        let path = '/pets';
        if (parameters['tags'] !== undefined) {
            queryParameters['tags'] = parameters['tags'];
        }
        if (parameters['limit'] !== undefined) {
            queryParameters['limit'] = parameters['limit'];
        }
        if (parameters.$queryParameters) {
            Object.keys(parameters.$queryParameters).forEach(function (parameterName) {
                queryParameters[parameterName] = parameters.$queryParameters[parameterName];
            });
        }
        let keys = Object.keys(queryParameters);
        return domain + path + (keys.length > 0 ? '?' + (keys.map(key => key + '=' + encodeURIComponent(queryParameters[key])).join('&')) : '');
    }
    /**
    * Returns all pets from the system that the user has access to
    Nam sed condimentum est. Maecenas tempor sagittis sapien, nec rhoncus sem sagittis sit amet. Aenean at gravida augue, ac iaculis sem. Curabitur odio lorem, ornare eget elementum nec, cursus id lectus. Duis mi turpis, pulvinar ac eros ac, tincidunt varius justo. In hac habitasse platea dictumst. Integer at adipiscing ante, a sagittis ligula. Aenean pharetra tempor ante molestie imperdiet. Vivamus id aliquam diam. Cras quis velit non tortor eleifend sagittis. Praesent at enim pharetra urna volutpat venenatis eget eget mauris. In eleifend fermentum facilisis. Praesent enim enim, gravida ac sodales sed, placerat id erat. Suspendisse lacus dolor, consectetur non augue vel, vehicula interdum libero. Morbi euismod sagittis libero sed lacinia.

    Sed tempus felis lobortis leo pulvinar rutrum. Nam mattis velit nisl, eu condimentum ligula luctus nec. Phasellus semper velit eget aliquet faucibus. In a mattis elit. Phasellus vel urna viverra, condimentum lorem id, rhoncus nibh. Ut pellentesque posuere elementum. Sed a varius odio. Morbi rhoncus ligula libero, vel eleifend nunc tristique vitae. Fusce et sem dui. Aenean nec scelerisque tortor. Fusce malesuada accumsan magna vel tempus. Quisque mollis felis eu dolor tristique, sit amet auctor felis gravida. Sed libero lorem, molestie sed nisl in, accumsan tempor nisi. Fusce sollicitudin massa ut lacinia mattis. Sed vel eleifend lorem. Pellentesque vitae felis pretium, pulvinar elit eu, euismod sapien.

    * @method
    * @name Test#findPets
         * @param {array} tags - tags to filter by
         * @param {integer} limit - maximum number of results to return
    */
    findPets(parameters) {
        const domain = parameters.$domain ? parameters.$domain : this.domain;
        let path = '/pets';
        let body;
        let queryParameters = {};
        let headers = {};
        let form = {};
        return new Promise((resolve, reject) => {
            headers['Accept'] = 'application/json';
            headers['Content-Type'] = 'application/json';
            if (parameters['tags'] !== undefined) {
                queryParameters['tags'] = parameters['tags'];
            }
            if (parameters['limit'] !== undefined) {
                queryParameters['limit'] = parameters['limit'];
            }
            if (parameters.$queryParameters) {
                Object.keys(parameters.$queryParameters).forEach(function (parameterName) {
                    queryParameters[parameterName] = parameters.$queryParameters[parameterName];
                });
            }
            this.request('GET', domain + path, body, headers, queryParameters, form, reject, resolve);
        });
    }
    addPetURL(parameters) {
        let queryParameters = {};
        const domain = parameters.$domain ? parameters.$domain : this.domain;
        let path = '/pets';
        if (parameters.$queryParameters) {
            Object.keys(parameters.$queryParameters).forEach(function (parameterName) {
                queryParameters[parameterName] = parameters.$queryParameters[parameterName];
            });
        }
        queryParameters = {};
        let keys = Object.keys(queryParameters);
        return domain + path + (keys.length > 0 ? '?' + (keys.map(key => key + '=' + encodeURIComponent(queryParameters[key])).join('&')) : '');
    }
    /**
     * Creates a new pet in the store.  Duplicates are allowed
     * @method
     * @name Test#addPet
     * @param {} pet - Pet to add to the store
     */
    addPet(parameters) {
        const domain = parameters.$domain ? parameters.$domain : this.domain;
        let path = '/pets';
        let body;
        let queryParameters = {};
        let headers = {};
        let form = {};
        return new Promise((resolve, reject) => {
            headers['Accept'] = 'application/json';
            headers['Content-Type'] = 'application/json';
            if (parameters['pet'] !== undefined) {
                body = parameters['pet'];
            }
            if (parameters['pet'] === undefined) {
                reject(new Error('Missing required  parameter: pet'));
                return;
            }
            if (parameters.$queryParameters) {
                Object.keys(parameters.$queryParameters).forEach(function (parameterName) {
                    queryParameters[parameterName] = parameters.$queryParameters[parameterName];
                });
            }
            form = queryParameters;
            queryParameters = {};
            this.request('POST', domain + path, body, headers, queryParameters, form, reject, resolve);
        });
    }
}
exports.default = Test;
string;
{
    let queryParameters = {};
    const domain = parameters.$domain ? parameters.$domain : this.domain;
    let path = '/pets/{id}';
    path = path.replace('{id}', `${parameters['id']}`);
    if (parameters.$queryParameters) {
        Object.keys(parameters.$queryParameters).forEach(function (parameterName) {
            queryParameters[parameterName] = parameters.$queryParameters[parameterName];
        });
    }
    let keys = Object.keys(queryParameters);
    return domain + path + (keys.length > 0 ? '?' + (keys.map(key => key + '=' + encodeURIComponent(queryParameters[key])).join('&')) : '');
}
/**
 * Returns a user based on a single ID, if the user does not have access to the pet
 * @method
 * @name Test#find pet by id
 * @param {integer} id - ID of pet to fetch
 */
find;
pet;
by;
id(parameters, {
    'id': number,
    $queryParameters: any,
    $domain: string
});
Promise < request.Response > {
    const: domain = parameters.$domain ? parameters.$domain : this.domain,
    let: path = '/pets/{id}',
    let: body, any: ,
    let: queryParameters, any = {},
    let: headers, any = {},
    let: form, any = {},
    return: new Promise((resolve, reject) => {
        headers['Accept'] = 'application/json';
        headers['Content-Type'] = 'application/json';
        path = path.replace('{id}', `${parameters['id']}`);
        if (parameters['id'] === undefined) {
            reject(new Error('Missing required  parameter: id'));
            return;
        }
        if (parameters.$queryParameters) {
            Object.keys(parameters.$queryParameters).forEach(function (parameterName) {
                queryParameters[parameterName] = parameters.$queryParameters[parameterName];
            });
        }
        this.request('GET', domain + path, body, headers, queryParameters, form, reject, resolve);
    })
};
deletePetURL(parameters, {
    'id': number,
    $queryParameters: any,
    $domain: string
});
string;
{
    let queryParameters = {};
    const domain = parameters.$domain ? parameters.$domain : this.domain;
    let path = '/pets/{id}';
    path = path.replace('{id}', `${parameters['id']}`);
    if (parameters.$queryParameters) {
        Object.keys(parameters.$queryParameters).forEach(function (parameterName) {
            queryParameters[parameterName] = parameters.$queryParameters[parameterName];
        });
    }
    let keys = Object.keys(queryParameters);
    return domain + path + (keys.length > 0 ? '?' + (keys.map(key => key + '=' + encodeURIComponent(queryParameters[key])).join('&')) : '');
}
/**
 * deletes a single pet based on the ID supplied
 * @method
 * @name Test#deletePet
 * @param {integer} id - ID of pet to delete
 */
deletePet(parameters, {
    'id': number,
    $queryParameters: any,
    $domain: string
});
Promise < request.Response > {
    const: domain = parameters.$domain ? parameters.$domain : this.domain,
    let: path = '/pets/{id}',
    let: body, any: ,
    let: queryParameters, any = {},
    let: headers, any = {},
    let: form, any = {},
    return: new Promise((resolve, reject) => {
        headers['Accept'] = 'application/json';
        headers['Content-Type'] = 'application/json';
        path = path.replace('{id}', `${parameters['id']}`);
        if (parameters['id'] === undefined) {
            reject(new Error('Missing required  parameter: id'));
            return;
        }
        if (parameters.$queryParameters) {
            Object.keys(parameters.$queryParameters).forEach(function (parameterName) {
                queryParameters[parameterName] = parameters.$queryParameters[parameterName];
            });
        }
        this.request('DELETE', domain + path, body, headers, queryParameters, form, reject, resolve);
    })
};
