"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const request = require("superagent");
/**
 *
 * @class Test
 * @param {(string)} [domainOrOptions] - The project domain.
 */
class Test {
    constructor(domain, logger) {
        this.logger = logger;
        this.domain = "";
        this.errorHandlers = [];
        if (domain) {
            this.domain = domain;
        }
    }
    getDomain() {
        return this.domain;
    }
    addErrorHandler(handler) {
        this.errorHandlers.push(handler);
    }
    request(method, url, body, headers, queryParameters, form, reject, resolve) {
        if (this.logger) {
            this.logger.log(`Call ${method} ${url}`);
        }
        let req = request(method, url).query(queryParameters);
        Object.keys(headers).forEach(key => {
            req.set(key, headers[key]);
        });
        if (body) {
            req.send(body);
        }
        if (typeof (body) === 'object' && !(body.constructor.name === 'Buffer')) {
            req.set('Content-Type', 'application/json');
        }
        if (Object.keys(form).length > 0) {
            req.type('form');
            req.send(form);
        }
        req.end((error, response) => {
            if (error || !response.ok) {
                reject(error);
                this.errorHandlers.forEach(handler => handler(error));
            }
            else {
                resolve(response);
            }
        });
    }
    User_exists__head_Users__id_URL(parameters) {
        let queryParameters = {};
        const domain = parameters.$domain ? parameters.$domain : this.domain;
        let path = '/Users/{id}';
        path = path.replace('{id}', `${parameters['id']}`);
        if (parameters.$queryParameters) {
            Object.keys(parameters.$queryParameters).forEach(function (parameterName) {
                queryParameters[parameterName] = parameters.$queryParameters[parameterName];
            });
        }
        let keys = Object.keys(queryParameters);
        return domain + path + (keys.length > 0 ? '?' + (keys.map(key => key + '=' + encodeURIComponent(queryParameters[key])).join('&')) : '');
    }
    /**
     * Check whether a model instance exists in the data source.
     * @method
     * @see {@link https://example.atlassian.net/wiki/pages/example|More info on the WIKI}
     * @name Test#User_exists__head_Users__id_
     * @param {string} id - Model id
     */
    User_exists__head_Users__id_(parameters) {
        const domain = parameters.$domain ? parameters.$domain : this.domain;
        let path = '/Users/{id}';
        let body;
        let queryParameters = {};
        let headers = {};
        let form = {};
        return new Promise((resolve, reject) => {
            headers['Accept'] = 'application/json, application/xml, text/xml, application/javascript, text/javascript';
            headers['Content-Type'] = application / json, application / x - www - form - urlencoded, application / xml, text / xml;
            path = path.replace('{id}', `${parameters['id']}`);
            if (parameters['id'] === undefined) {
                reject(new Error('Missing required  parameter: id'));
                return;
            }
            if (parameters.$queryParameters) {
                Object.keys(parameters.$queryParameters).forEach(function (parameterName) {
                    queryParameters[parameterName] = parameters.$queryParameters[parameterName];
                });
            }
            this.request('HEAD', domain + path, body, headers, queryParameters, form, reject, resolve);
        });
    }
}
exports.default = Test;
